﻿using System.Data.SQLite;
using System.Windows.Forms;

namespace DirtyWordsFeedback
{
    public partial class DataForm : Form
    {
        App app = App.getApp();

        private bool beginAddData = false;

        public DataForm()
        {
            InitializeComponent();
            initView();
        }

        private void initView()
        {
            string sql = "select * from data order by id desc";
            SQLiteCommand command = new SQLiteCommand(sql, app.Connection);
            SQLiteDataReader reader = command.ExecuteReader();
            int index = 1;
            while (reader.Read())
            {
                //int index = dataGridView.Rows.Add();
                //dataGridView.Rows[index].Cells[0].Value = reader["id"];
                //dataGridView.Rows[index].Cells[1].Value = reader["content"];
                //dataGridView.Rows[index].Cells[2].Value = reader["level"];

                DataGridViewRow row = new DataGridViewRow();
                row.Tag = reader["id"];
                DataGridViewTextBoxCell id = new DataGridViewTextBoxCell();
                object idText = index;
                id.Value = idText;
                id.ToolTipText = idText.ToString();
                row.Cells.Add(id);
                DataGridViewTextBoxCell content = new DataGridViewTextBoxCell();
                object contentText = reader["content"];
                content.Value = contentText;
                content.ToolTipText = (string)contentText;
                row.Cells.Add(content);
                DataGridViewComboBoxCell level = new DataGridViewComboBoxCell();
                level.Items.Add("轻度");
                level.Items.Add("中度");
                level.Items.Add("重度");
                string levelText = reader["level"].ToString();
                level.Value = levelText;
                level.ToolTipText = levelText;
                row.Cells.Add(level);
                dataGridView.Rows.Add(row);
                index++;
            }
        }

        private void dataGridView_UserAddedRow(object sender, DataGridViewRowEventArgs e)
        {
            // 添加数据
            beginAddData = true;
        }

        private void dataGridView_CellBeginEdit(object sender, DataGridViewCellCancelEventArgs e)
        {
            // 开始编辑
            string idText = dataGridView.NewRowIndex + 1 + "";
            DataGridViewTextBoxCell id = (DataGridViewTextBoxCell)dataGridView.Rows[e.RowIndex].Cells["id"];
            if (id.Value == null)
            {
                id.Value = idText;
                id.ToolTipText = idText;
            }
            string levelText = "轻度";
            DataGridViewComboBoxCell level = (DataGridViewComboBoxCell)dataGridView.Rows[e.RowIndex].Cells["level"];
            if (level.Value == null)
            {
                level.Value = levelText;
                level.ToolTipText = levelText.ToString();
            }
        }

        private void dataGridView_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            // 结束编辑
            DataGridViewTextBoxCell id = (DataGridViewTextBoxCell)dataGridView.Rows[e.RowIndex].Cells["id"];
            DataGridViewTextBoxCell content = (DataGridViewTextBoxCell)dataGridView.Rows[e.RowIndex].Cells["content"];
            DataGridViewComboBoxCell level = (DataGridViewComboBoxCell)dataGridView.Rows[e.RowIndex].Cells["level"];
            if (beginAddData)
            {
                // 新增数据
                beginAddData = false;
                string sql = "INSERT INTO \"data\" (\"content\", \"level\") VALUES ('" + content.Value + "', '" + level.Value + "') ;select last_insert_rowid() FROM data";
                SQLiteCommand command = new SQLiteCommand(sql, app.Connection);
                dataGridView.Rows[e.RowIndex].Tag = command.ExecuteScalar();
            }
            else
            {
                // 修改数据
                DataGridViewRow row = dataGridView.CurrentRow;
                string sql = "UPDATE \"data\" SET \"content\"='" + row.Cells["content"].Value + "', \"level\"='" + row.Cells["level"].Value + "' WHERE (\"id\"=" + row.Tag + ")";
                SQLiteCommand command = new SQLiteCommand(sql, app.Connection);
                command.ExecuteNonQuery();
            }
        }

        private void dataGridView_UserDeletingRow(object sender, DataGridViewRowCancelEventArgs e)
        {
            // 删除前的用户确认
            if (MessageBox.Show("确认要删除该行数据吗？", "删除确认", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) != DialogResult.OK)
            {
                // 如果不是 OK，则取消。 
                e.Cancel = true;
            }
        }

        private void dataGridView_UserDeletedRow(object sender, DataGridViewRowEventArgs e)
        {
            // 删除数据
            for(int index = dataGridView.CurrentRow.Index + 1; index < dataGridView.Rows.Count; index++)
            {
                // ID 列重排序
                // dataGridView.Rows[index - 1].Cells["id"].Value = index.ToString();
            }
            new SQLiteCommand("DELETE FROM data WHERE (\"id\"=" + e.Row.Tag + ")", app.Connection).ExecuteNonQuery();
        }
    }
}
